(function () {
    tinymce.PluginManager.add('wpfresh4_lorem_button', function (editor, url) {

        editor.addButton('wpfresh4_lorem_button', {
            text: 'Sample Text',
            icon: 'mce-ico mce-i-code',
            title: 'WP Freshstart Sample Text Generator',
            onclick: function () {
                editor.windowManager.open({
                    title: 'Enter Number of Words (max 1500):',
                    body: [
                        {
                            type: 'textbox',
                            name: 'num',
                            label: 'Total Words:'
                        }
                    ],
                    onsubmit: function (e) {
                        var content = srzGetWords(e.data.num);
                        editor.insertContent(content);
                    }
                });
            }
        });
    });
})();

function srzGetWords(num) {
    var loremtext = "Lorem ipsum dolor sit amet, consectetur adipiscing elit. Nunc bibendum nec sem sit amet tristique. Fusce tristique nulla nec lacus consectetur, nec elementum enim ultricies. Nullam felis urna, tincidunt vitae ullamcorper sed, vestibulum eu dui. In ultricies nulla at nibh hendrerit, id tempor est venenatis. Vestibulum aliquam tincidunt diam semper ultricies. In sagittis sem ut ultrices ornare. Nunc mauris tortor, molestie sed libero pharetra, rutrum maximus libero.<br/><br/>Etiam nunc dolor, malesuada at blandit at, faucibus nec ante. Nunc maximus scelerisque tellus aliquet blandit. In hac habitasse platea dictumst. Nulla risus felis, aliquam quis viverra ac, venenatis sed ante. Quisque volutpat augue ut aliquam lobortis. Nullam eu diam venenatis, vehicula nunc dapibus, consectetur lorem. Nulla ullamcorper consequat erat, vel blandit dolor sodales sed.<br/><br/>Curabitur pharetra congue aliquet. Curabitur lobortis non turpis luctus maximus. Ut vehicula hendrerit leo, eu congue justo ullamcorper non. Pellentesque sagittis nibh est, eu pharetra neque egestas in. Vestibulum ante ipsum primis in faucibus orci luctus et ultrices posuere cubilia Curae; Integer eleifend tincidunt tortor vitae rutrum. Aliquam efficitur nunc non ante consectetur scelerisque. Mauris sodales cursus turpis pellentesque vestibulum. Pellentesque blandit enim vel eros finibus bibendum. Suspendisse rhoncus neque eget velit elementum facilisis. Fusce in dui convallis urna interdum elementum ac at justo. Cras mauris nisl, ultricies molestie turpis et, rutrum interdum lorem. Curabitur vitae ligula et eros tempor sollicitudin non nec nisi. Fusce volutpat eget leo nec interdum. Donec scelerisque lobortis leo porta ullamcorper.<br/><br/>Curabitur ac imperdiet quam. Phasellus a aliquet felis, non ornare libero. Aliquam fermentum arcu quis placerat sodales. Nunc a purus dui. Suspendisse nulla ligula, tincidunt volutpat nibh ut, mattis pellentesque orci. Duis sodales, neque sit amet viverra tristique, tortor nisi tincidunt massa, ac pharetra nulla lectus et libero. Nullam non bibendum ex. Donec feugiat aliquet vestibulum.";
    // var start = Math.floor((Math.random() * 500) + 1);
    var start = 0;
    var parsedNum = parseInt(num);
    if (isNaN(parsedNum)) parsedNum = 5;
    if (parsedNum < 1) parsedNum = 5;
    if (parsedNum > 1500) parsedNum = 1500;
    var tempStr = loremtext.split(/\s+/).slice(start, start + parsedNum).join(" ");
    return tempStr.charAt(0).toUpperCase() + tempStr.slice(1);
}