<?php
function wpfresh4_scripts_and_styles() {
	wp_enqueue_script( 'fresh4-jquery-cookie', WPFRESH4_URL . '/js/front/jquery.cookie-1.4.1.min.js',	array( 'jquery' ), '1.4.1' );

	wp_register_script( 'wpfresh4_front_js', WPFRESH4_URL . '/js/wpfresh4-front.js', array( 'jquery' ), WPFRESH4_VERSION);

	$legal = wpfresh4_get_settings( array( 'content', 'legal' ) );

    $script_vars = array(
            'message' => ( isset( $legal['cookiew_text'] ) && $legal['cookiew_text'] ) ? $legal['cookiew_text'] : '',
            'button'  => ( isset( $legal['cookiew_accept'] ) && $legal['cookiew_accept'] ) ? $legal['cookiew_accept'] : '',
            'more'    => __( 'Read More...', 'cookie-pop' ),
            'url'     => ( isset( $legal['cookiew_url'] ) && $legal['cookiew_url'] ) ? $legal['cookiew_url'] : '',
            'cookie_enabled'  => ( isset( $legal['cookiew_enabled'] ) && $legal['cookiew_enabled'] ) ? 1 : 0
    );

	wp_localize_script( 'wpfresh4_front_js', 'wpfresh4_vars', $script_vars );
	wp_enqueue_script( 'wpfresh4_front_js' );

    $pinterest = wpfresh4_get_settings( array( 'social', 'pinterest', 'pin_img' ) );
    if( $pinterest )
        wp_enqueue_script( 'fresh4-pinterest', WPFRESH4_URL . '/js/front/wpfresh4-pinterest.js',   array( 'jquery' ), WPFRESH4_VERSION );

    wp_register_style( 'wpfresh4_front_css', WPFRESH4_URL . '/css/wpfresh4-front.css', array(), WPFRESH4_VERSION );
    wp_enqueue_style( 'wpfresh4_front_css' );

    wp_register_style( 'wpfresh4_fa', '//maxcdn.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css', array(), WPFRESH4_VERSION);
    wp_enqueue_style( 'wpfresh4_fa' );

    $enable_fonts = wpfresh4_get_settings( array( 'content', 'fonts', 'enable_fonts' ) );
    if( !$enable_fonts )
        return;
    $fonts_txt = '';
    for( $i=1; $i<6;$i++ ) {
        $font = wpfresh4_get_settings( array( 'content', 'fonts', 'font'.$i ) );
        if( $font )
            $fonts_txt .= str_replace( ' ', '+', $font).'|';
    }
    wp_register_style('wpfresh4_google_fonts_front', WPFRESH4_GOOGLE_FONTS_URL.'/css?family='.$fonts_txt);
    wp_enqueue_style( 'wpfresh4_google_fonts_front');


}

add_action( 'wp_enqueue_scripts', 'wpfresh4_scripts_and_styles' );
?>