<?php

/* Menu */

add_action ( 'admin_menu', 'wpfresh4_add_admin_menu' );

function wpfresh4_add_admin_menu() {
    require_once( WPFRESH4_DIR.'/lib/styles/styles.php');
    // ask_delete_license();
    $style1 = ask2_lic_status();
    $page1 = add_menu_page( 'WP Freshstart', 'WP Freshstart', 'manage_options', 'wp-freshstart', ($style1 ? 'wpfresh4_screen_main' : 'ask2_settings'), WPFRESH4_URL.'/img/wp-fresh-icon.png' );
    add_action( "admin_print_scripts", 'wpfresh4_admin_scriptsc' );

    if( $style1 ) {
        $page2 = add_submenu_page( 'wp-freshstart', 'Content', 'Content', 'manage_options', 'wp-freshstart-content', 'wpfresh4_screen_content' );
        $page3 = add_submenu_page( 'wp-freshstart', 'Plugins', 'Plugins', 'manage_options', 'wp-freshstart-plugins', 'wpfresh4_screen_plugins' );
        $page4 = add_submenu_page( 'wp-freshstart', 'Security', 'Security', 'manage_options', 'wp-freshstart-security', 'wpfresh4_screen_security' );
        $page5 = add_submenu_page( 'wp-freshstart', 'SEO', 'SEO', 'manage_options', 'wp-freshstart-seo', 'wpfresh4_screen_seo' );
        if( wpfresh4_is_pro() ) {
            $page6 = add_submenu_page( 'wp-freshstart', 'Branding', 'Branding', 'manage_options', 'wp-freshstart-branding', 'wpfresh4_screen_branding' );
            $page7 = add_submenu_page( 'wp-freshstart', 'Social', 'Social', 'manage_options', 'wp-freshstart-social', 'wpfresh4_screen_social' );
        }
        $page8 = add_submenu_page( 'wp-freshstart', 'Others', 'Others', 'manage_options', 'wp-freshstart-others', 'wpfresh4_screen_others' );
        $page9 = add_submenu_page( 'wp-freshstart', 'InstaReset', 'InstaReset', 'manage_options', 'wp-freshstart-reset', 'wpfresh4_screen_reset' );
        $page10 = add_submenu_page( 'wp-freshstart', 'Help', 'Help', 'manage_options', 'wp-freshstart-support', 'wpfresh4_screen_help' );
        // remove_submenu_page( 'wp-freshstart', 'wp-freshstart' );


        add_action( "admin_print_scripts-$page2", 'wpfresh4_admin_scripts' );
        add_action( "admin_print_styles-$page2", 'wpfresh4_admin_style' );
        add_action( "admin_print_styles-$page2", 'wpfresh4_admin_style_fonts' );
        add_action( "admin_print_scripts-$page3", 'wpfresh4_admin_scripts' );
        add_action( "admin_print_styles-$page3", 'wpfresh4_admin_style' );
        add_action( "admin_print_scripts-$page4", 'wpfresh4_admin_scripts' );
        add_action( "admin_print_styles-$page4", 'wpfresh4_admin_style' );
        add_action( "admin_print_scripts-$page5", 'wpfresh4_admin_scripts' );
        add_action( "admin_print_styles-$page5", 'wpfresh4_admin_style' );
        if( wpfresh4_is_pro() ) {
            add_action( "admin_print_scripts-$page6", 'wpfresh4_admin_scripts' );
            add_action( "admin_print_styles-$page6", 'wpfresh4_admin_style' );
            add_action( "admin_print_scripts-$page7", 'wpfresh4_admin_scripts' );
            add_action( "admin_print_styles-$page7", 'wpfresh4_admin_style' );
        }
        add_action( "admin_print_scripts-$page8", 'wpfresh4_admin_scripts' );
        add_action( "admin_print_styles-$page8", 'wpfresh4_admin_style' );
        add_action( "admin_print_scripts-$page9", 'wpfresh4_admin_scripts' );
        add_action( "admin_print_styles-$page9", 'wpfresh4_admin_style' );
        add_action( "admin_print_scripts-$page10", 'wpfresh4_admin_scripts' );
        add_action( "admin_print_styles-$page10", 'wpfresh4_admin_style' );
    }
    add_action( "admin_print_scripts-$page1", 'wpfresh4_admin_scripts' );
    add_action( "admin_print_styles-$page1", 'wpfresh4_admin_style' );
}

function wpfresh4_admin_scripts() {
	wp_register_script( 'wpfresh4_admin_js', WPFRESH4_URL . '/js/wpfresh4-admin.js', array( 'jquery' ), WPFRESH4_VERSION);

    $script_vars = array(
		'admin_url' => admin_url( 'admin.php?page=wp-freshstart' )
	 );
	wp_localize_script( 'wpfresh4_admin_js', 'wpfresh4_vars', $script_vars );
	wp_enqueue_script( 'wpfresh4_admin_js' );

	wp_register_script( 'wpfresh4-formalize',
	        WPFRESH4_URL . '/js/formalize.js',
	        array( 'jquery' ) );
	wp_enqueue_script( 'wpfresh4-formalize' );
    wp_enqueue_script('wp-color-picker');
    wp_enqueue_style( 'wp-color-picker' );
    wp_enqueue_media( );
}

function wpfresh4_admin_scriptsc() {
    wp_register_script( 'wpfresh4_admin_jsc', WPFRESH4_URL . '/js/wpfresh4-admin2.js', array('jquery'), WPFRESH4_VERSION );
    wp_enqueue_script( 'wpfresh4_admin_jsc');
}


function wpfresh4_admin_style() {
	wp_register_style( 'wpfresh4_font_awesome_css', '//maxcdn.bootstrapcdn.com/font-awesome/4.7.0/css/font-awesome.min.css', array(), WPFRESH4_VERSION);
	wp_enqueue_style( 'wpfresh4_font_awesome_css' );

	wp_register_style( 'wpfresh4_custom_css', WPFRESH4_URL . '/css/wpfresh4-admin.css', array(), WPFRESH4_VERSION);
	wp_enqueue_style( 'wpfresh4_custom_css' );
}

function wpfresh4_admin_style_fonts() {
    $enable_fonts = wpfresh4_get_settings( array( 'content', 'fonts', 'enable_fonts' ) );
    if( !$enable_fonts )
        return;
    $fonts_txt = '';
    for( $i=1; $i<6;$i++ ) {
        $font = wpfresh4_get_settings( array( 'content', 'fonts', 'font'.$i ) );
        if( $font )
            $fonts_txt .= str_replace( ' ', '+', $font).'|';
    }
    wp_register_style('wpfresh4_google_fonts', WPFRESH4_GOOGLE_FONTS_URL.'/css?family='.$fonts_txt);
    wp_enqueue_style( 'wpfresh4_google_fonts');
}

function wpfresh4_cpt_enqueue( $hook_suffix ){
    if( in_array($hook_suffix, array('post.php', 'post-new.php') ) ){
        $screen = get_current_screen();
        if( is_object( $screen ) ){
            wpfresh4_admin_style_fonts();
        }
    }
}

add_action( 'admin_enqueue_scripts', 'wpfresh4_cpt_enqueue');

function wpfresh4_screen_main() {
	if ( !current_user_can ( 'manage_options' ))
		wp_die ( 'You don\'t have access to this page.' );
	if ( !user_can_access_admin_page ())
		wp_die ( __ ( 'You do not have sufficient permissions to access this page', 'wp-freshstart' ) );
    ?>
	<div class="wrap">
		<img src="<?php echo WPFRESH4_URL;?>/img/wpfs4logo.png" alt="">
        <?php if( isset( $_GET['quickw'] ) ) {
            echo '<h1>WP Freshstart - Quick Settings <a href="#" id="wpfresh4-expand-all" class="button button-secondary" style="float:right"><i class="fa fa-expand"></i> Expand all</a></h1><br/>';
            wpfresh4_quick_wizard();
            echo '<br/></div>';
            return;
        }
        else {
        ?>
        <h1>WP Freshstart <?php if( wpfresh4_is_pro() ) echo 'Pro';?></h1>
        <br/>
        <p>WP Freshstart 4.0 helps you save precious minutes (sometimes hours!) when setting up your WordPress site</p>
        <p><a href="<?php echo admin_url('admin.php?page=wp-freshstart');?>&quickw=true" class="button button-primary"><i class="fa fa-lightbulb-o"></i> Click here to use our Quick Settings</a><br/><br/>or use any of the advanced settings below:</p>
        <!-- <p>Here are the different settings you can configure:</p> -->
        <p>

        <?php
            if( wpfresh4_is_pro() ) {
                $els = array(
                    array(
                        'id' => 'content',
                        'header' => 'Content',
                        'desc' => 'Create content automatically'
                    ),
                    array(
                        'id' => 'plugins',
                        'header' => 'Plugins',
                        'desc' => 'Install plugins with one click'
                    ),
                    array(
                        'id' => 'security',
                        'header' => 'Security',
                        'desc' => 'Avoid getting your content stolen, and your website hacked'
                    ),
                    array(
                        'id' => 'seo',
                        'header' => 'SEO',
                        'desc' => 'Take action to improve your rankings in Search Engines'
                    ),
                    array(
                        'id' => 'branding',
                        'header' => 'Branding',
                        'desc' => 'Change the look and feel of the WordPress admin area with your own settings (ideal for your clients)'
                    ),
                    array(
                        'id' => 'social',
                        'header' => 'Social',
                        'desc' => 'Add social buttons, metadata, or share your content'
                    ),
                    array(
                        'id' => 'others',
                        'header' => 'Others',
                        'desc' => 'Other settings (optimize, footer/header code, email...)'
                    ),
                    array(
                        'id' => 'reset',
                        'header' => 'InstaReset',
                        'desc' => 'Reset all database tables (handle with care!)'
                    ),
                );
            }
            else {
                $els = array(
                    array(
                        'id' => 'content',
                        'header' => 'Content',
                        'desc' => 'Create content automatically'
                    ),
                    array(
                        'id' => 'plugins',
                        'header' => 'Plugins',
                        'desc' => 'Install plugins with one click'
                    ),
                    array(
                        'id' => 'security',
                        'header' => 'Security',
                        'desc' => 'Avoid getting your content stolen'
                    ),
                    array(
                        'id' => 'seo',
                        'header' => 'SEO',
                        'desc' => 'Take action to improve your rankings in Search Engines'
                    ),
                    array(
                        'id' => 'others',
                        'header' => 'Others',
                        'desc' => 'Other settings (optimize, footer/header code, email...)'
                    ),
                    array(
                        'id' => 'reset',
                        'header' => 'InstaReset',
                        'desc' => 'Reset all database tables (handle with care!)'
                    ),
                );
            }
         ?>
            <table class="widefat wpfs4-table" style="width:auto">
                <tbody>
                    <?php
                        $i = 1;
                        foreach( $els as $el ) {
                        ?>
                            <tr <?php if ( $i % 2 ) echo 'class="alternate"';?>>
                                <td class="row-title"><label><?php echo $i;?>. <?php echo $el['header'];?></label></td>
                                <td><?php echo $el['desc'];?></td>
                                <td><a href="<?php echo admin_url('admin.php?page=wp-freshstart-'.$el['id']);?>" class="button button-secondary"> <i class="fa fa-cog"></i> Configure</a></td>
                            </tr>
                        <?php
                            $i++;
                        }
                    ?>
                </tbody>
            </table>
        </p>
        <br/>
	</div>
	<?php
}
}

function wpfresh4_screen_content() {
    if ( !current_user_can ( 'manage_options' ))
        wp_die ( 'You don\'t have access to this page.' );
    if ( !user_can_access_admin_page ())
        wp_die ( __ ( 'You do not have sufficient permissions to access this page', 'wp-freshstart' ) );
    ?>
    <div class="wrap">
        <img src="<?php echo WPFRESH4_URL;?>/img/wpfs4logo.png" alt="">
        <h1>1. Content</h1>
        <br/>
        <?php wpfresh4_settings_content(); ?>
        <br/>
    </div>
    <?php
}

function wpfresh4_screen_plugins() {
    if ( !current_user_can ( 'manage_options' ))
        wp_die ( 'You don\'t have access to this page.' );
    if ( !user_can_access_admin_page ())
        wp_die ( __ ( 'You do not have sufficient permissions to access this page', 'wp-freshstart' ) );
    ?>
    <div class="wrap">
        <img src="<?php echo WPFRESH4_URL;?>/img/wpfs4logo.png" alt="">
        <h1>2. Recommended Plugins</h1>
        <br/>
        <?php wpfresh4_settings_plugins(); ?>
        <br/>
    </div>
    <?php
}

function wpfresh4_screen_security() {
    if ( !current_user_can ( 'manage_options' ))
        wp_die ( 'You don\'t have access to this page.' );
    if ( !user_can_access_admin_page ())
        wp_die ( __ ( 'You do not have sufficient permissions to access this page', 'wp-freshstart' ) );
    ?>
    <div class="wrap">
        <img src="<?php echo WPFRESH4_URL;?>/img/wpfs4logo.png" alt="">
        <h1>3. Security</h1>
        <br/>
        <?php wpfresh4_settings_security(); ?>
        <br/>
    </div>
    <?php
}

function wpfresh4_screen_seo() {
    if ( !current_user_can ( 'manage_options' ))
        wp_die ( 'You don\'t have access to this page.' );
    if ( !user_can_access_admin_page ())
        wp_die ( __ ( 'You do not have sufficient permissions to access this page', 'wp-freshstart' ) );
    ?>
    <div class="wrap">
        <img src="<?php echo WPFRESH4_URL;?>/img/wpfs4logo.png" alt="">
        <h1>4. SEO</h1>
        <br/>
        <?php wpfresh4_settings_seo(); ?>
        <br/>
    </div>
    <?php
}

function wpfresh4_screen_branding() {
    if ( !current_user_can ( 'manage_options' ))
        wp_die ( 'You don\'t have access to this page.' );
    if ( !user_can_access_admin_page ())
        wp_die ( __ ( 'You do not have sufficient permissions to access this page', 'wp-freshstart' ) );
    ?>
    <div class="wrap">
        <img src="<?php echo WPFRESH4_URL;?>/img/wpfs4logo.png" alt="">
        <h1>5. Branding</h1>
        <br/>
        <?php wpfresh4_settings_branding(); ?>
        <br/>
    </div>
    <?php
}

function wpfresh4_screen_social() {
    if ( !current_user_can ( 'manage_options' ))
        wp_die ( 'You don\'t have access to this page.' );
    if ( !user_can_access_admin_page ())
        wp_die ( __ ( 'You do not have sufficient permissions to access this page', 'wp-freshstart' ) );
    ?>
    <div class="wrap">
        <img src="<?php echo WPFRESH4_URL;?>/img/wpfs4logo.png" alt="">
        <h1>6. Social</h1>
        <br/>
        <?php wpfresh4_settings_social(); ?>
        <br/>
    </div>
    <?php
}

function wpfresh4_screen_others() {
    if ( !current_user_can ( 'manage_options' ))
        wp_die ( 'You don\'t have access to this page.' );
    if ( !user_can_access_admin_page ())
        wp_die ( __ ( 'You do not have sufficient permissions to access this page', 'wp-freshstart' ) );
    ?>
    <div class="wrap">
        <img src="<?php echo WPFRESH4_URL;?>/img/wpfs4logo.png" alt="">
        <h1><?php if( wpfresh4_is_pro() ) echo '7'; else echo '5';?>. Others</h1>
        <br/>
        <?php wpfresh4_settings_others(); ?>
        <br/>
    </div>
    <?php
}

function wpfresh4_screen_reset() {
    if ( !current_user_can ( 'manage_options' ))
        wp_die ( 'You don\'t have access to this page.' );
    if ( !user_can_access_admin_page ())
        wp_die ( __ ( 'You do not have sufficient permissions to access this page', 'wp-freshstart' ) );
    ?>
    <div class="wrap">
        <img src="<?php echo WPFRESH4_URL;?>/img/wpfs4logo.png" alt="">
        <h1>Instareset</h1>
        <br/>
        <?php wpfresh4_instareset(); ?>
        <br/>
    </div>
    <?php
}

function wpfresh4_screen_help() {
    if ( !current_user_can ( 'manage_options' ))
        wp_die ( 'You don\'t have access to this page.' );
    if ( !user_can_access_admin_page ())
        wp_die ( __ ( 'You do not have sufficient permissions to access this page', 'wp-freshstart' ) );
    ?>
    <div class="wrap">
        <img src="<?php echo WPFRESH4_URL;?>/img/wpfs4logo.png" alt="">
        <h1>Help</h1>
        <br/>
        <h2>How to use the plugin</h2>
        <?php if( wpfresh4_is_pro() ) { ?>
            <iframe width="853" height="480" src="https://www.youtube.com/embed/BxwS2_psph4?rel=0&amp;showinfo=0" frameborder="0" allowfullscreen></iframe>
        <?php } else { ?>
            <iframe width="853" height="480" src="https://www.youtube.com/embed/YCLQw9VuBws?rel=0&amp;showinfo=0" frameborder="0" allowfullscreen></iframe>
        <?php } ?>
        <br/>
        <br/>
        <h2>FAQ</h2>
        <h4>1. I have purchased the Pro version, do I need to install both plugins?</h4>
        <p>No, you just need to install the <a href="http://wpfreshstart4.com/v4/pro/" target="_blank">Pro version</a> (which has all the functionality). In fact, if you try to install both, you will get an error, so if you have already installed the basic version, please deactivate and uninstall it first, then install the Pro version</p>
        <h4>2. After configuring some security settings, my site is broken</h4>
        <p>Some of the features in the plugin (especially security) might not be compatible with your hosting company.</p>
        <p>If something is broken, please try the following:</p>
        <p>a) <a target="_blank" href="<?php echo site_url('?wpfresh4_dis_sec=1');?>">click here</a> to disable security settings</p>
        <p>b) If that does not help, review security settings in the WP Freshtart plugin and disable everything</p>
        <p>c) Disable the plugin and see if the problems continue.</p>
        <p>d) <a target="_blank" href="http://wpfreshstart4.com/help.html">Open a support ticket</a> letting us know which settings you enabled, the url of your site, and if you are seeing any errors, and our tech team will give you a hand</a>
        <h4>3. I cannot see any images in the gallery</h4>
        <p>If all your images suddenly disappeared, try the following:</p>
        <p>a) Go to WP Freshstart, Security, and disable the checbox "Disable image hotlinking", then click on "Save all changes"
        <p>b) If you still can't see the images, login via ftp and delete the file wp-content/uploads/.htaccess (make a backup first)</p>
        <p>c) <a target="_blank" href="http://wpfreshstart4.com/help.html">Open a support ticket</a> and our tech team will give you a hand</a>
        <br/>
        <br/>
        <a class="button button-primary" href="http://wpfreshstart4.com/help.html" target="_blank">Click here to get support</a>
        <br/>
    </div>
    <?php
}

/* Field Types */

function wpfresh4_field_text( $label = '', $name = '', $value = '', $id = false, $class = '',  $help = '', $placeholder = '', $row_class = '', $row_visible = true ) {
    if( !empty( $placeholder ) )
        $placeholder = ' placeholder="'.$placeholder.'"';
    if( !empty( $id ) )
        $id = ' id="'.$id.'"';
    if( empty( $value ) )
        $value = '';
    if( !empty( $row_class ) )
        $row_class = ' class="'.$row_class.'"';
?>
    <tr valign="top" <?php echo $row_class;?> <?php if( !$row_visible ) echo 'style="display:none"';?>>
        <th scope="row"><?php echo $label;?></th>
        <td>
            <input type="text" class="regular-text <?php echo $class;?>" name="<?php echo $name;?>" <?php echo $id;?> <?php echo $placeholder;?> value="<?php echo stripslashes( $value ); ?>">
            <?php if( !empty( $help ) ) { ?>
                <p class="description"><?php echo $help;?></p>
            <?php } ?>
        </td>
    </tr>
<?php
}

function wpfresh4_field_password( $label = '', $name = '', $value = '', $id = false, $classes = '',  $help = '', $placeholder = '', $row_class = '', $row_visible = true ) {
    if( !empty( $placeholder ) )
        $placeholder = ' placeholder="'.$placeholder.'"';
    if( !empty( $id ) )
        $id = ' id="'.$id.'"';
    if( empty( $value ) )
        $value = '';
    if( !empty( $row_class ) )
        $row_class = ' class="'.$row_class.'"';
?>
    <tr valign="top" <?php echo $row_class;?> <?php if( !$row_visible ) echo 'style="display:none"';?>>
        <th scope="row"><?php echo $label;?></th>
        <td>
            <input type="password" class="regular-text" name="<?php echo $name;?>" <?php echo $id;?> <?php echo $placeholder;?> value="<?php echo stripslashes( $value ); ?>">
            <?php if( !empty( $help ) ) { ?>
                <span class="description"><?php echo $help;?></span>
            <?php } ?>
        </td>
    </tr>
<?php
}

function wpfresh4_field_textarea( $label = '', $name = '', $value = '', $id = false, $class = '',  $help = '', $placeholder = '', $row_class = '', $row_visible = true ) {
    if( !empty( $placeholder ) )
        $placeholder = ' placeholder="'.$placeholder.'"';
    if( !empty( $id ) )
        $id = ' id="'.$id.'"';
    if( empty( $value ) )
        $value = '';
    if( !empty( $row_class ) )
        $row_class = ' class="'.$row_class.'"';
?>
    <tr valign="top" <?php echo $row_class;?> <?php if( !$row_visible ) echo 'style="display:none"';?>>
        <th scope="row"><?php echo $label;?></th>
        <td>
            <textarea class="<?php echo $class;?>" name="<?php echo $name;?>" <?php echo $id;?> <?php echo $placeholder;?>><?php echo stripslashes( $value ); ?></textarea>
            <?php if( !empty( $help ) ) { ?>
                <p class="description"><?php echo $help;?></p>
            <?php } ?>
        </td>
    </tr>
<?php
}

function wpfresh4_field_checkbox( $label = '', $name = '', $value = '', $id = false, $class = '',  $help = '', $placeholder = '', $row_class = '', $row_visible = true ) {
    // var_dump($value);
    if ( $value )
        $checked = checked( $value, 1, false );
    else
        $checked = '';
    if( !empty( $placeholder ) )
        $placeholder = ' placeholder="'.$placeholder.'"';
    if( !empty( $id ) )
        $id = ' id="'.$id.'"';
    if( empty( $value ) )
        $value = '';
    if( !empty( $row_class ) )
        $row_class = ' class="'.$row_class.'"';
    if( !empty( $class ) )
        $class = ' class="'.$class.'"';
    ?>
        <tr valign="top" <?php echo $row_class;?> <?php if( !$row_visible ) echo 'style="display:none"';?>>
            <th scope="row"><?php echo $label;?></th>
            <td>
                <input type="checkbox" name="<?php echo $name;?>" <?php echo $id;?> <?php echo $class;?> <?php echo $checked;?> value="1">
                <?php if( !empty( $help ) ) { ?>
                    <p class="description"><?php echo $help;?></p>
                <?php } ?>
            </td>
        </tr>
<?php
}

function wpfresh4_field_checkbox_inner( $label = '', $name = '', $value = '', $id = false, $class = '',  $help = '', $placeholder = '', $row_class = '', $row_visible = true ) {
    if ( $value )
        $checked = checked( true, true, false );
    else
        $checked = '';
        if( !empty( $placeholder ) )
            $placeholder = ' placeholder="'.$placeholder.'"';
        if( !empty( $id ) )
            $id = ' id="'.$id.'"';
        if( empty( $value ) )
            $value = '';
        if( !empty( $row_class ) )
            $row_class = ' class="'.$row_class.'"';
    ?>
        <tr valign="top" <?php echo $row_class;?> <?php if( !$row_visible ) echo 'style="display:none"';?>>
            <th scope="row" style="padding:0;padding-right:10px">&nbsp;</th>
            <td style="padding:0;padding-left:10px">
                <label><input type="checkbox" name="<?php echo $name;?>" <?php echo $id;?> <?php echo $class;?> <?php echo $checked;?> value="1"> <?php echo $label;?></label>
                <?php if( !empty( $help ) ) { ?>
                    <p class="description"><?php echo $help;?></p>
                <?php } ?>
            </td>
        </tr>
<?php
}
function wpfresh4_field_select( $label = '', $name = '', $value = '', $values = array(), $id = false, $help = '', $extra_help = '', $class = '', $row_class = '', $hidden = false, $extra_option = false ) {
    if( !empty( $id ) )
        $id = ' id="'.$id.'"';
    if( empty( $value ) )
        $value = '';
    if( !empty( $row_class ) )
        $row_class = ' class="'.$row_class.'"';
?>
    <tr valign="top" <?php echo $row_class;?> <?php if( $hidden ) echo 'style="display:none"';?>>
        <th scope="row"><?php echo $label;?></th>
        <td>
            <select <?php echo $id;?> class="<?php echo $class; ?>" name="<?php echo $name;?>"><?php wpfresh4_select_options( $value, $values, $extra_option );?></select>
            <?php if( !empty( $help ) ) { ?>
                <p class="description"><?php echo $help;?></p>
            <?php } ?>
        </td>
    </tr>
<?php
}

function wpfresh4_field_color( $label = '', $name = '', $value = '', $id = false, $class = '',  $help = '', $placeholder = '', $row_class = '', $row_visible = true ) {
    if( !empty( $placeholder ) )
        $placeholder = ' placeholder="'.$placeholder.'"';
    if( !empty( $id ) )
        $id = ' id="'.$id.'"';
    if( empty( $value ) )
        $value = '';
    if( !empty( $row_class ) )
        $row_class = ' class="'.$row_class.'"';
?>
    <tr valign="top" <?php echo $row_class;?> <?php if( !$row_visible ) echo 'style="display:none"';?>>
        <th scope="row"><?php echo $label;?></th>
        <td>
            <input type="text" class="regular-text wpfresh4-color-picker <?php echo $class;?>" name="<?php echo $name;?>" <?php echo $id;?> <?php echo $placeholder;?> value="<?php echo stripslashes( $value ); ?>">
            <?php if( !empty( $help ) ) { ?>
                <p class="description"><?php echo $help;?></p>
            <?php } ?>
        </td>
    </tr>
<?php
}

function wpfresh4_field_html( $label = '', $name = '', $value = '', $id = false, $class = '',  $help = '', $placeholder = '', $row_class = '', $row_visible = true ) {
    if( !empty( $placeholder ) )
        $placeholder = ' placeholder="'.$placeholder.'"';
    if( !empty( $id ) )
        $id = ' id="'.$id.'"';
    if( empty( $value ) )
        $value = '';
    if( !empty( $row_class ) )
        $row_class = ' class="'.$row_class.'"';

    $value = htmlspecialchars_decode( $value );

    $settings = array (
        'textarea_name' => $name,
        'textarea_rows' => 14,
        'editor_height' => 320
        );
    $ta_id = str_replace( array( '[', ']' ), '_', 'wpfresh4_'.$name );
    $value = stripslashes( $value );
?>
    <tr valign="top" <?php echo $row_class;?> <?php if( !$row_visible ) echo 'style="display:none"';?>>
        <th scope="row"><?php echo $label;?></th>
        <td>
            <?php wp_editor( $value, $ta_id, $settings ); ?>
            <?php if( !empty( $help ) ) { ?>
                <p class="description"><?php echo $help;?></p>
            <?php } ?>
        </td>
    </tr>
<?php
}
/* Custom */
function wpfresh4_field_category( $label = '', $name = '', $value = '', $id = false, $classes = '',  $help = '', $placeholder = '' ) {
    if( !empty( $placeholder ) )
        $placeholder = ' placeholder="'.$placeholder.'"';
    if( !empty( $id ) )
        $id = ' id="'.$id.'"';
    if( empty( $value ) )
        $value = '';
?>
    <tr valign="top">
        <th scope="row"><?php echo $label;?></th>
        <td>
            <?php
                $args = array(
                    'name' => $name,
                    'selected' => $value,
                    'show_option_none' => '- None -',
                    'option_none_value' => 0,
                );
                wp_dropdown_categories( $args );
            ?>
            <?php if( !empty( $help ) ) { ?>
                <span class="description"><?php echo $help;?></span>
            <?php } ?>
        </td>
    </tr>
<?php
}


function wpfresh4_field_author( $label = '', $name = '', $value = '', $id = false, $classes = '',  $help = '', $placeholder = '' ) {
    if( !empty( $id ) )
        $id = ' id="'.$id.'"';
    if( empty( $value ) )
        $value = '';
?>
    <tr valign="top">
        <th scope="row"><?php echo $label;?></th>
        <td>
            <?php
                wp_dropdown_users(array( 'name' => $name, 'selected' => $value ) );
            ?>
            <?php if( !empty( $help ) ) { ?>
                <br/><span class="description"><?php echo $help;?></span>
            <?php } ?>
        </td>
    </tr>
<?php
}

function wpfresh4_field_custom_post_type( $label = '', $name = '', $values = '', $id = false, $class = '',  $help = '', $placeholder = '', $row_class = '', $row_visible = true ) {
    // if ( $value )
    //     $checked = checked( true, true, false );
    // else
    //     $checked = '';
    if( !empty( $placeholder ) )
        $placeholder = ' placeholder="'.$placeholder.'"';
    if( !empty( $id ) )
        $id = ' id="'.$id.'"';
    if( empty( $value ) )
        $value = '';
    if( !empty( $row_class ) )
        $row_class = ' class="'.$row_class.'"';
    if( !empty( $class ) )
        $class = ' class="'.$class.'"';
    ?>
        <tr valign="top" <?php echo $row_class;?> <?php if( !$row_visible ) echo 'style="display:none"';?>>
            <th scope="row"><?php echo $label;?></th>
            <td>
            <?php
                $args = array(
                    'public'   => true,
                  //  '_builtin' => false
                );

                $output = 'objects'; // names or objects, note names is the default
                $operator = 'and'; // 'and' or 'or'

                $post_types = get_post_types( $args, $output, $operator );
                // var_dump($post_types);
                if( $post_types ) {
                    $i = 1;
                    foreach ( $post_types  as $post_type ) {
                        $pt_name = $post_type->name;
                        if( 'attachment' == $pt_name )
                            continue;
                        $pt_label = $post_type->label;
                        $enabled = 0;
                        $checked = '';
                        if( wpfresh4_posttype_checked( $pt_name, $values ) )
                            $checked = 'checked = "checked"';
                ?>
                    <label><input type="checkbox" name="<?php echo $name;?>[<?php echo $pt_name;?>]" <?php echo $class;?> <?php echo $checked;?> value="1"> <?php echo $pt_label;?> </label><br/>
                <?php } } ?>
                <?php if( !empty( $help ) ) { ?>
                    <p class="description"><?php echo $help;?></p>
                <?php } ?>
            </td>
        </tr>
    <?php
}

function wpfresh4_field_image( $label = '', $name = '', $value = '', $id = false, $class = '',  $help = '', $placeholder = '', $row_class = '', $row_visible = true ) {
    if( !empty( $placeholder ) )
        $placeholder = ' placeholder="'.$placeholder.'"';
    if( !empty( $id ) )
        $id = ' id="'.$id.'"';
    if( empty( $value ) )
        $value = '';
    $hide_img = false;

    // if( !empty( $row_class ) )
    //     $row_class = ' class="'.$row_class.'"';
?>
    <tr valign="top" class="file-upload-parent <?php echo $row_class;?>" <?php if( !$row_visible ) echo 'style="display:none"';?>>
        <th scope="row"><?php echo $label;?></th>
        <td>
            <input class="regular-text file-upload-url" type="text" size="36" name="<?php echo $name;?>" value="<?php echo $value;?>" placeholder="Select file..." />
            <button class="button button-secondary wpfresh4_img_upload" type="button"><i class="fa fa-upload"></i> Select Image</button>
            <button class="button button-secondary wpfresh4_img_clear" type="button"><i class="fa fa-remove"></i></button>
            <?php if( !empty( $help ) ) { ?>
                <p class="description"><?php echo $help;?></p>
            <?php } ?>
            <?php if ( !$hide_img) { ?>
                <br/>
                <br/>
                <img src="<?php echo $value; ?>" alt="" class="file-upload-img wpfresh4-admin-img">
            <?php } ?>
        </td>
    </tr>
<?php
}


function wpfresh4_field_image_( $settings, $property, $label = '', $name = '', $id = false, $placeholder = '', $help = '', $extra_help = '', $class = '', $row_class = '', $hidden = false ) {
    if ( isset( $settings->{$property} ) )
        $value = $settings->{$property};
    else
        $value = '';

    if( !empty( $placeholder ) )
        $placeholder = ' placeholder="'.$placeholder.'"';
    if( !empty( $id ) )
        $id = ' id="'.$id.'"';
    if( empty( $value ) )
        $value = '';

    $hide_img = false;
?>
    <tr valign="top" class="file-upload-parent <?php echo $row_class;?>" <?php if( $hidden ) echo 'style="display:none"';?>>
        <th scope="row"><?php echo $label;?></th>
        <td>
            <input class="regular-text file-upload-url" type="text" size="36" name="<?php echo $name;?>" value="<?php echo $value;?>" placeholder="Select file..." />
            <button class="button button-secondary wpfresh4_img_upload" type="button"><span class="fa fa-upload"></span> Select Image</button>
            <?php if( !empty( $help ) ) { ?>
                <span class="description"><?php echo $help;?></span>
            <?php } ?>
            <?php if ( !$hide_img) { ?>
                <br/>
                <br/>
                <img src="<?php echo $value; ?>" alt="" class="file-upload-img wpfresh4-admin-img">
            <?php } ?>
        </td>
    </tr>
<?php
}
/*
function wpfresh4_field_datepicker( $label = '', $name = '', $value = '', $id = false, $classes = '',  $help = '', $placeholder = '' ) {
    if( !empty( $placeholder ) )
        $placeholder = ' placeholder="'.$placeholder.'"';
    if( !empty( $id ) )
        $id = ' id="'.$id.'"';
?>
    <tr valign="top">
        <th scope="row"><?php echo $label;?></th>
        <td>
            <input type="text" class="regular-text" name="<?php echo $name;?>" <?php echo $id;?> <?php echo $placeholder;?> value="<?php echo $value; ?>">
            <?php if( !empty( $help ) ) { ?>
                <span class="description"><?php echo $help;?></span>
            <?php } ?>
        </td>
    </tr>
<?php
}
*/

function wpfresh4_field_hidden( $name = '', $value = '', $id = '', $class='' ) {
    if( !empty( $id ) )
        $id = ' id="'.$id.'"';
    echo '<input type="hidden" name="'.$name.'" value="'.$value.'" class="'.$class.'" />';
}

/*
function wpfresh4_ifield_html( $settings, $property, $label = '', $name = '', $id = false, $placeholder = '', $help = '', $extra_help = '', $class = '', $row_class = '', $hidden = false ) {
    if ( isset( $settings->{$property} ) )
        $value = htmlspecialchars_decode( $settings->{$property} );
        // $value = $settings->{$property};
    else
        $value = '';

    if( !empty( $placeholder ) )
        $placeholder = ' placeholder="'.$placeholder.'"';
    if( !empty( $id ) )
        $id = ' id="'.$id.'"';
    if( empty( $value ) )
        $value = '';
    if( !empty( $row_class ) )
        $row_class = ' class="'.$row_class.'"';

    $settings = array (
        'textarea_name' => $name,
        'textarea_rows' => 14,
        'editor_height' => 320
        );
    $ta_id = str_replace( array( '[', ']' ), '_', 'wpfresh4_'.$name );
    $value = stripslashes( $value );
?>
    <tr valign="top" <?php echo $row_class;?> <?php if( $hidden ) echo 'style="display:none"';?>>
        <th scope="row"><?php echo $label;?></th>
        <td>
            <?php wp_editor( $value, $ta_id, $settings ); ?>
            <?php if( !empty( $help ) ) { ?>
                <span class="description"><?php echo $help;?></span>
            <?php } ?>
        </td>
    </tr>
<?php
}

function wpfresh4_ifield_image( $settings, $property, $label = '', $name = '', $id = false, $placeholder = '', $help = '', $extra_help = '', $class = '', $row_class = '', $hidden = false ) {
    if ( isset( $settings->{$property} ) )
        $value = $settings->{$property};
    else
        $value = '';

    if( !empty( $placeholder ) )
        $placeholder = ' placeholder="'.$placeholder.'"';
    if( !empty( $id ) )
        $id = ' id="'.$id.'"';
    if( empty( $value ) )
        $value = '';

    $hide_img = false;
?>
    <tr valign="top" class="file-upload-parent <?php echo $row_class;?>" <?php if( $hidden ) echo 'style="display:none"';?>>
        <th scope="row"><?php echo $label;?></th>
        <td>
            <input class="regular-text file-upload-url" type="text" size="36" name="<?php echo $name;?>" value="<?php echo $value;?>" placeholder="Select file..." />
            <button class="button button-secondary wpfresh4_img_upload" type="button"><span class="fa fa-upload"></span> Select Image</button>
            <?php if( !empty( $help ) ) { ?>
                <span class="description"><?php echo $help;?></span>
            <?php } ?>
            <?php if ( !$hide_img) { ?>
                <br/>
                <br/>
                <img src="<?php echo $value; ?>" alt="" class="file-upload-img wpfresh4-banner-img">
            <?php } ?>
        </td>
    </tr>
<?php
}

*/


/* Helper functions */

function wpfresh4_select_options( $current_value = 0, $values=array(), $extra_option = false ) {
    if ($values) {
        if ($extra_option) {
            if( is_string( $extra_option ) )
                $txt = $extra_option;
            else
                $txt = 'Select...';
            ?>
                <option value="0"><?php echo $txt; ?></option>
            <?php
        }
        foreach ($values as $value) {
            // var_dump($value);
            if ($value['value'] === 'optgroup' ) {
                ?>
                    <optgroup label="<?php echo $value['label'];?>">
                <?php
            }   else if (/*$value['value'] &&*/ $value['value'] === 'optgroupclose' ) {
                    ?>
                    </optgroup>
            <?php
                } else {
            ?>
                <option value="<?php echo $value['value'];?>" <?php wpfresh4_selected( $current_value, $value['value'] );?>><?php echo $value['label'];?></option>
            <?php
            }
        }
    }
}

function wpfresh4_checked($current_value, $compare_value=true, $echo=1) {
    if ( $current_value == $compare_value ) {
        if ($echo) {
            echo ' checked="checked" ';
        }
        return ' checked="checked" ';
    }
}

function wpfresh4_selected( $current_value, $compare_value = 'true', $echo = 1 ) {
    if ( $current_value && ( $current_value == $compare_value ) ) {
        if ($echo) {
            echo ' selected="selected" ';
        }
        return ' selected="selected" ';
    }
}

function wpfresh4_get_selected_in_array($haystack, $needle) {
    if ( $haystack ) {
        foreach ( $haystack as $element ) {
            if ( $element['value'] == $needle )
                return $element['label'];
        }
    }
    return '';
}

function wpfresh4_posttype_checked( $pt_name, $values ) {
    if( empty( $values ) )
        return false;
    foreach( $values as $key => $value ) {
        if( $key == $pt_name )
            return true;
    }
    return false;
}

// Notice in backend
add_action( 'admin_init', 'wpfresh4_check_initial_notice' );

function wpfresh4_check_initial_notice() {
    $ndis = get_option( 'wpfresh4-ndis' );
    if( empty( $ndis ) ) {
        add_action( 'admin_notices', 'wpfresh4_initial_admin_notice', -1 );
    }
}

function wpfresh4_initial_admin_notice() {
    ?>
    <div class="notice updated wpfresh4-anotice is-dismissible" >
        <p><?php _e( '<b>WP Freshstart 5 is available!</b>. Full GDPR support, Amazon ads and much more <b><a href="http://wpfreshstart5.com/upgrade.html" target="_blank">Click here to claim your discount</a></b>', 'wp-freshstart4' ); ?></p>
    </div>
    <?php
}

?>