<?php
/*
Plugin Name: WP Freshstart 4 Pro
Version: 4.7
Plugin URI: http://wpfreshstart4.com
Description: This 1-Click Plugin does all the menial WordPress tasks needed to setup a brand new site. Also can instantly RESET an existing site back to a freshly setup WordPress.
Author: Ankur Shukla
*/

if ( ! defined( 'ABSPATH' ) ) exit; // Exit if accessed directly

define( 'WPFRESH4_VERSION', '4.7' );
if (!isset($wp_version))
    global $wp_version;
define( 'WPFRESH4_WPVERSION', $wp_version );

// define( 'WPFRESH4_DEBUG_MODE', 0 );

define( 'WPFRESH4_PLUGIN_NAME', dirname(plugin_basename(__FILE__) ));
define( 'WPFRESH4_DIR', plugin_dir_path( __FILE__ ) );
define( 'WPFRESH4_URL', plugins_url( WPFRESH4_PLUGIN_NAME ) );

include WPFRESH4_DIR.'/lib/common.php';
include WPFRESH4_DIR.'/lib/utils.php';
include WPFRESH4_DIR.'/lib/settings.php';

//include WPFRESH4_DIR.'/lib/minify/cache/';
//include WPFRESH4_DIR.'/lib/minify/config.php';


if ( is_admin() ) {
	include WPFRESH4_DIR.'/lib/ui.php';
	include WPFRESH4_DIR.'/lib/plugins/fresh4_plugins.php';
	include WPFRESH4_DIR.'/lib/instareset/insta-reset.php';
	include WPFRESH4_DIR.'/lib/styles/dashboard.php';
}
else {
	include WPFRESH4_DIR.'lib/frontend.php';
}

include WPFRESH4_DIR.'/lib/content.php';
include WPFRESH4_DIR.'/lib/security.php';
include WPFRESH4_DIR.'/lib/others.php';
include WPFRESH4_DIR.'/lib/seo.php';

if( wpfresh4_is_pro() ) {
	include WPFRESH4_DIR.'/lib/branding.php';
	include WPFRESH4_DIR.'/lib/social.php';
	include WPFRESH4_DIR.'/lib/antispam.php';
}

/* Automatic Updates */
require WPFRESH4_DIR.'/lib/plugin-updates/plugin-update-checker.php';
$puchcker = new Puc_v4p2_Plugin_UpdateChecker(
    ( wpfresh4_is_pro() ? 'https://wpfreshstart.s3.amazonaws.com/plugin-updates/4/2-pro/info_freshstart2.json' : 'https://wpfreshstart.s3.amazonaws.com/plugin-updates/4/1-std/info_freshstart.json' ),
    WPFRESH4_DIR.WPFRESH4_PLUGIN_NAME.'.php'
);

register_deactivation_hook( __FILE__, 'wpfs4_plugin_deactivated' );
?>